diff a/src/hotspot/share/classfile/modules.hpp b/src/hotspot/share/classfile/modules.hpp
--- a/src/hotspot/share/classfile/modules.hpp
+++ b/src/hotspot/share/classfile/modules.hpp
@@ -30,11 +30,11 @@
 
 class ModuleEntryTable;
 class Symbol;
 
 class Modules : AllStatic {
-  static void check_cds_restrictions(TRAPS) NOT_CDS_JAVA_HEAP_RETURN;
+  static void check_cds_restrictions(Handle module1, Handle module2, TRAPS) NOT_CDS_JAVA_HEAP_RETURN;
 
 public:
   // define_module defines a module containing the specified packages. It binds the
   // module to its class loader by creating the ModuleEntry record in the
   // ClassLoader's ModuleEntry table, and creates PackageEntry records in the class
@@ -59,11 +59,12 @@
   static void define_archived_modules(Handle h_platform_loader, Handle h_system_loader,
                                       TRAPS) NOT_CDS_JAVA_HEAP_RETURN;
   static void verify_archived_modules() NOT_CDS_JAVA_HEAP_RETURN;
   static void dump_main_module_name() NOT_CDS_JAVA_HEAP_RETURN;
   static void serialize(SerializeClosure* soc) NOT_CDS_JAVA_HEAP_RETURN;
-
+  static bool is_dynamic_proxy_module(Handle module);
+  static bool is_dynamic_proxy_module(ModuleEntry* module_entry);
 #if INCLUDE_CDS_JAVA_HEAP
   static char* _archived_main_module_name;
 #endif
 
   // Provides the java.lang.Module for the unnamed module defined
